<id>
vWarn Mod
</id>

<version>
1.10
</version>

<mod info>
A warning system based on membergroups
</mod info>

<author>
Valodim
</author>

<homepage>
mugenguild.com
</homepage>



<edit file>
index.php
</edit file>

<search for>
		// Log this user as online.
		writeLog();
</search for>

<add after>
		// call autowarn to unwarn members
		if ($modSettings['autoWarningTime'] < time())
			autoWarn();
</add after>



<edit file>
$sourcedir/Load.php
</edit file>


<search for>
	global $modSettings, $sourcedir, $user_settings;
</search for>

<replace>
	global $modSettings, $sourcedir, $user_settings, $warningGroups;
</replace>


<search for>
		$ID_MEMBER = !empty($ID_MEMBER) && strlen($password) == 40 && $login_span > time() ? (int) $ID_MEMBER : 0;
	}
</search for>

<add after>

	// load all warning groups. this is used in many places and required in this very function, so we've gotta load it HERE. :)
	$warningGroups = array();
	$result = db_query("
		SELECT ID_GROUP, groupName, onlineColor, stars
			FROM {$db_prefix}membergroups
			WHERE minPosts = -2", __FILE__, __LINE__);
	while($row = mysql_fetch_assoc($result)) {
		$warningGroups[$row['ID_GROUP']] = $row;
		// set up the warning light. just use the image, the number doesn't matter
		$warningGroups[$row['ID_GROUP']]['light'] = substr(strstr($row['stars'], '#'), 1);
	}
	mysql_free_result($result);
</add after>


<search for>
	}
	// If the user is a guest, initialize all the critial user settings.
</search for>

<add before>
		// we do this here, so we don't have to do it for warnings seperately ;)
		$user_info['groups'] = array_unique($user_info['groups']);
		// only warning-groups in this one :D
		$user_info['warnings'] = array_intersect($user_info['groups'], array_keys($warningGroups));
</add before>


<search for>
		$user_info = array('groups' => array(-1));
</search for>

<replace>
		$user_info = array('groups' => array(-1), 'warnings' => array());
</replace>


<search for>
	);
	$user_info['groups'] = array_unique($user_info['groups']);
</search for>

<replace>
	);
	// PLACEHOLDER FOR VWARNMOD, DON'T REMOVE!
</replace>


<search for>
	else
		$user_info['query_see_board'] = '(FIND_IN_SET(' . implode(', b.memberGroups) OR FIND_IN_SET(', $user_info['groups']) . ', b.memberGroups))';
</search for>

<replace>
	else {
		$user_info['query_see_board'] = '(FIND_IN_SET(' . implode(', b.memberGroups) OR FIND_IN_SET(', array_diff($user_info['groups'], $user_info['warnings'])) . ', b.memberGroups))';
		// adjust this, so users which are in board with a warning memberGroup do NOT have access!
		if(!empty($user_info['warnings']))
			$user_info['query_see_board'] .= ' AND NOT FIND_IN_SET(' . implode(', b.memberGroups) AND NOT FIND_IN_SET(', $user_info['warnings']) . ', b.memberGroups)';
	}
</replace>


<search for>
		if (count(array_intersect($user_info['groups'], $board_info['groups'])) == 0 && !$user_info['is_admin'])
</search for>

<replace>
		if ((count(array_intersect($user_info['groups'], $board_info['groups'])) == 0 || count(array_intersect($user_info['warnings'], $board_info['groups'])) > 0) && !$user_info['is_admin'])
</replace>


<search for>
			pg.onlineColor AS post_group_color, IFNULL(pg.groupName, '') AS post_group,
</search for>

<replace>
			pg.onlineColor AS post_group_color, IFNULL(pg.groupName, '') AS post_group, mem.additionalGroups, w.data as warningData,
</replace>


<search for>
			LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = mem.ID_GROUP)";
	}
	elseif ($set == 'profile')
</search for>

<replace>
			LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = mem.ID_GROUP)
			LEFT JOIN {$db_prefix}log_warnings AS w ON (w.ID_WARNED = mem.ID_MEMBER AND w.valid = 1)";
	}
	elseif ($set == 'profile')
</replace>


<search for>
			LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = mem.ID_GROUP)";
	}
	elseif ($set == 'minimal')
</search for>

<replace>
			LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = mem.ID_GROUP)
			LEFT JOIN {$db_prefix}log_warnings AS w ON (w.ID_WARNED = mem.ID_MEMBER AND w.valid = 1)";
	}
	elseif ($set == 'minimal')
</replace>


<search for>
	global $board_info, $settings, $db_prefix;
</search for>

<replace>
	global $board_info, $settings, $db_prefix, $warningGroups;
</replace>


<search for>
	// What a monstrous array...
</search for>

<add before>

	// check if there's a warning, if there is, take the one which is going to expire at first (last?) and gets its light
	if(!empty($profile['warningData']) && $warnings = @unserialize($profile['warningData']))
		// if there are any non-permanent warnings left, use them first!
		if($warnings2 = array_filter($warnings, 'isnotminusone')) {
			// sort, fetch the first one only and get its data
			asort($warnings2);
			$warning = $warningGroups[reset(array_keys($warnings2))];
		} else
			$warning = $warningGroups[array_search(-1, $warnings)];

</add before>


<search for>
		'post_group_color' => $profile['post_group_color'],
</search for>

<add after>
		'warning' => empty($warning) ? array() : array(
				'name' => $warning['groupName'],
				'color' => $warning['onlineColor'],
				'light' => $warning['light'],
			),
</add after>


<search for>
// Load a theme, by ID.
function loadTheme($ID_THEME = 0, $initialize = true)
</search for>

<add before>
// subfunction, just returns true if the given parameter is not equal -1
function isnotminusone($entry) {
	return $entry != -1;
}

</add before>


<edit file>
$sourcedir/ManageMembergroups.php
</edit file>

<search for>
		'post' => array()
</search for>

<replace>
		'post' => array(),
		'warning' => array(),
</replace>


<search for>
		$context['groups'][$row['minPosts'] == -1 ? 'regular' : 'post'][$row['ID_GROUP']] = array(
</search for>

<replace>
		$context['groups'][$row['minPosts'] == -1 ? 'regular' : ($row['minPosts'] == -2 ? 'warning' : 'post')][$row['ID_GROUP']] = array(
</replace>


<search for>
			'is_post_group' => $row['minPosts'] != -1,
</search for>

<replace>
			'is_post_group' => $row['minPosts'] >= 0,
			'is_warning_group' => $row['minPosts'] == -2,
</replace>


<search for>
		$postCountBasedGroup = isset($_POST['min_posts']) && (!isset($_POST['postgroup_based']) || !empty($_POST['postgroup_based']));
</search for>

<replace>
		$warningBasedGroup = !empty($_POST['warninggroup_based']);
		$postCountBasedGroup = isset($_POST['min_posts']) && !empty($_POST['postgroup_based']);
</replace>


<search for>
			VALUES ($ID_GROUP, '$_POST[group_name]', " . ($postCountBasedGroup ? (int) $_POST['min_posts'] : '-1') . ", '1#star.gif')", __FILE__, __LINE__);
</search for>

<replace>
			VALUES ($ID_GROUP, '$_POST[group_name]', " . ($warningBasedGroup ? -2 : ($postCountBasedGroup ? (int) $_POST['min_posts'] : '-1')) . ", '1#star.gif')", __FILE__, __LINE__);
</replace>


<search for>
	$context['post_group'] = !empty($_REQUEST['postgroup']);
	$context['undefined_group'] = empty($_REQUEST['postgroup']) && empty($_REQUEST['generalgroup']);
</search for>

<replace>

	// to avoid errors
	$context['general_group'] = false;
	$context['post_group'] = false;
	$context['warning_group'] = false;
	$context['undefined_group'] = false;
	// what kind of group? but, limit to one .V.
	if(!empty($_REQUEST['generalgroup']))
		$context['general_group'] = true;
	elseif(!empty($_REQUEST['postgroup']))
		$context['post_group'] = true;
	elseif(!empty($_REQUEST['warninggroup']))
		$context['warning_group'] = true;
	else
		$context['undefined_group'] = true;
</replace>


<search for>
		$_POST['min_posts'] = isset($_POST['min_posts']) && $_POST['post_group'] == '1' && $_REQUEST['group'] > 3 ? abs($_POST['min_posts']) : ($_REQUEST['group'] == 4 ? 0 : -1);
</search for>

<replace>
		$_POST['min_posts'] = isset($_POST['min_posts']) && $_POST['post_group'] == '1' && $_REQUEST['group'] > 3 ? abs($_POST['min_posts']) : ($_REQUEST['group'] == 4 ? 0 : ($_POST['warning_group'] ? -2 : -1));
</replace>


<search for>
		'is_post_group' => $row['minPosts'] != -1,
</search for>

<replace>
		'is_post_group' => $row['minPosts'] >= 0,
		'is_warning_group' => $row['minPosts'] == -2,
		'allow_special_groups' => $_REQUEST['group'] == 2 || $_REQUEST['group'] > 4,
</replace>


<search for>
		SELECT ID_GROUP AS id, groupName AS name, minPosts = -1 AS assignable, minPosts != -1 AS is_post_group
</search for>

<replace>
		SELECT ID_GROUP AS id, groupName AS name, minPosts = -1 AS assignable, minPosts > 0 AS is_post_group
</replace>


<edit file>
$sourcedir/Security.php
</edit file>


<search for>
	// We should never get to this point, but if we did we wouldn't know the user isn't a guest.
	trigger_error('Hacking attempt...', E_USER_ERROR);
}
</search for>

<add after>

// This checks for members with warnings, and unwarns if expired :)
function autoWarn() {

	global $db_prefix, $modSettings;

	// check every 2 hours (this isn't THAT much work, it will most probably just skip through, anyways)
	updateSettings(array('autoWarningTime' => time() + $modSettings['autoWarnDelay']), true);

	// for keeping track of members with expired warnings / invalid warning log entries
	$expiredmembers = array();
	$invalid = array();

	// fetch all still-valid entries
	$result = db_query("
		SELECT ID_WARNING, ID_MEMBER, time, data
			FROM {$db_prefix}log_warnings
			WHERE valid = 1", __FILE__, __LINE__);
	while($row = mysql_fetch_assoc($result)) {
		// group => expires
		$expired = unserialize($row['data']);
		// this is used to keep track if any warning is expired
		$stillvalid = false;
		// sort out all non-expired and permament warnings
		foreach($expired as $group => $expires)
			if($expires <= 0 || ($row['time'] + $expires) > time()) {
				unset($expired[$group]);
				// if any warning is sorted out, this warning-group is invalid
				$stillvalid = true;
			}
		// if there are any expired warnings left, keep it
		if(!empty($expired))
			$expiredmembers[$row['ID_MEMBER']] = array_keys($expired);

		// if there's any warning left, set "valid" to 0 for this entry!
		if(!$stillvalid)
			$invalid[] = $row['ID_WARNING'];
	}
	mysql_free_result($result);

	// if there are any left
	if(!empty($expiredmembers)) {

		// fetch all members
		$result = db_query("
			SELECT ID_MEMBER, additionalGroups
				FROM {$db_prefix}members
				WHERE ID_MEMBER IN (" . implode(array_keys($expiredmembers)) . ")", __FILE__, __LINE__);
		while($row = mysql_fetch_assoc($result)) {
			// list all groups, minus those in the expired array
			$groups = array_diff(explode(',', $row['additionalGroups']), $expiredmembers[$row['ID_MEMBER']]);
			// update the additional membergroups of the member :D
			updateMemberData($row['ID_MEMBER'], array('additionalGroups' => '\'' . implode(',', $groups) . '\''));
		}
		mysql_free_result($result);
	}

	// kill all now not valid anymore entries, so they aren't processed next time
	if(!empty($invalid))
		db_query("
			UPDATE {$db_prefix}log_warnings
				SET valid = 0
				WHERE ID_WARNING IN (" . implode(',', $invalid) . ")", __FILE__, __LINE__);

}
</add after>



<edit file>
$sourcedir/Profile.php
</edit file>


<search for>
	global $txt, $scripturl, $user_info, $context, $ID_MEMBER, $sourcedir, $user_profile, $modSettings;
</search for>

<replace>
	global $txt, $scripturl, $user_info, $context, $ID_MEMBER, $sourcedir, $user_profile, $modSettings, $warningGroups;
</replace>


<search for>
		'forumProfile' => array(array('profile_extra_any', 'profile_extra_own'), array('profile_extra_any')),
</search for>

<add after>
		'warn' => array(array('vwarn_warn'), array('vwarn_warn')),
		'warnLog' => array(array('vwarn_viewlog_own'), array('vwarn_viewlog_any')),
</add after>


<search for>
		if (allowedTo('manage_permissions'))
			$context['profile_areas']['info']['areas']['showPermissions'] = '<a href="' . $scripturl . '?action=profile;u=' . $memID . ';sa=showPermissions">' . $txt['showPermissions'] . '</a>';
</search for>

<add after>
		if (($context['user']['is_owner'] && allowedTo('vwarn_viewlog_own')) || allowedTo('vwarn_viewlog_any'))
			$context['profile_areas']['info']['areas']['warnLog'] = '<a href="' . $scripturl . '?action=profile;u=' . $memID . ';sa=warnLog">' . $txt['warnLog'] . '</a>';
</add after>


<search for>
		// You shouldn't PM (or ban really..) yourself!! (only administrators see this because it's not in the menu.)
		if (!$context['user']['is_owner'] && allowedTo('pm_send'))
			$context['profile_areas']['profile_action']['areas']['send_pm'] = '<a href="' . $scripturl . '?action=pm;sa=send;u=' . $memID . '">' . $txt['profileSendIm'] . '</a>';
</search for>

<add after>
		// The user wouldn't want to warn himself ;)
		if (allowedTo('vwarn_warn'))
			$context['profile_areas']['profile_action']['areas']['warn'] = '<a href="' . $scripturl . '?action=profile;u=' . $memID . ';sa=warn">' . $txt['warn'] . '</a>';
</add after>


<search for>
		'group' => $user_profile[$memID]['ID_GROUP'],
</search for>

<add after>
		'additionalGroups' => !empty($user_profile[$memID]['additionalGroups']) ? explode(',', $user_profile[$memID]['additionalGroups']) : array(),
		'warnings' => array_intersect(explode(',', $user_profile[$memID]['additionalGroups']), array_keys($warningGroups)),
</add after>


<search for>
	global $context, $memberContext, $txt, $modSettings, $user_info, $user_profile, $sourcedir, $db_prefix;
</search for>

<replace>
	global $context, $memberContext, $txt, $modSettings, $user_info, $user_profile, $sourcedir, $db_prefix, $warningGroups;
</replace>


<search for>
		'can_have_buddy' => allowedTo('profile_identity_own'),
</search for>

<add after>
		'warn_groups' => &$warningGroups,
</add after>


<search for>
	$context['member'] = &$memberContext[$memID];
</search for>

<replace>
	// we trick this one, for easines' sake :P
	$warnings = $context['member']['warnings'];
	$context['member'] = &$memberContext[$memID];
	$context['member']['warnings'] = $warnings;
</replace>


<search for>
	global $db_prefix, $user_info, $txt, $modSettings, $user_profile, $newpassemail, $validationCode, $context, $settings, $sourcedir;
</search for>

<replace>
	global $db_prefix, $user_info, $txt, $modSettings, $user_profile, $newpassemail, $validationCode, $context, $settings, $sourcedir, $warningGroups;
</replace>


<search for>
					$_POST['additionalGroups'][$i] = (int) $group_id;
			}
</search for>

<add after>
			// add warning groups, those can't be unset here ;)
                        $_POST['additionalGroups'] = array_merge($_POST['additionalGroups'], array_intersect(explode(',', $old_profile['additionalGroups']), array_keys($warningGroups)));
</add after>


<search for>
			if (!isset($context['member']['options'][$k]))
				$context['member']['options'][$k] = $v;
		}
	}
}
</search for>

<add after>

function warn($memID) {

	global $ID_MEMBER, $scripturl, $txt, $sourcedir, $context, $db_prefix, $warningGroups;

	// quick validation
	validateSession();

	// get post id (either from POST form or GET var) and validate it
	$postid = !empty($_POST['post_check']) && !empty($_POST['post_id']) ? (int) $_POST['post_id'] : (empty($_GET['postid']) ? 0 : (int) $_GET['postid']);
	if($postid != 0) {
		$result = db_query("
			SELECT ID_TOPIC
				FROM {$db_prefix}messages
				WHERE ID_MSG = $postid AND ID_MEMBER = $memID", __FILE__, __LINE__);
		if(($row = mysql_fetch_assoc($result)) === false)
			fatal_lang_error('postnotusers');
		$context['topic'] = $row['ID_TOPIC'];
		mysql_free_result($result);
	}

	// if there was data submitted, process it
	if(!empty($_POST['submit'])) {

		// prevent double submission of this form.
		checkSubmitOnce('check');

		// needed for parsing and notify
		include($sourcedir . '/Subs-Post.php');

		// get all warning groups and their expiry dates
		$data = array();
		foreach($warningGroups as $id => $group)
			if(!empty($_POST['group'][$id]) && ((float) $_POST['group'][$id]) != 0) {
                        	if(((float) $_POST['group'][$id]) > 0)
					$data[$id] = (int) round(((float) $_POST['group'][$id]) * 24 * 60 * 60);
				else
					$data[$id] = -1;
			}

		// now set the user's membergroups (old groups minus old warning groups plus new warning groups, only one time each)
		$groups = array_unique(array_merge(array_diff($context['member']['additionalGroups'], array_keys($warningGroups)), array_keys($data)));

		// update the additional membergroups of the member :D
		updateMemberData($memID, array('additionalGroups' => '\'' . implode(',', $groups) . '\''));

		// go on by serializing data for storage =)
		$sdata = serialize($data);

		// one special treatment for the note
		$note = htmlspecialchars($_POST['note'], ENT_QUOTES);
		preparsecode($note);

		// invalidate all previous warnings. yep.
		db_query("
                  UPDATE {$db_prefix}log_warnings
                    SET valid = 0
                    WHERE ID_MEMBER = $memID", __FILE__, __LINE__);

		// this one's valid now. yep.
		db_query("
			INSERT INTO {$db_prefix}log_warnings
				(ID_MEMBER, ID_WARNED, ID_MSG, time, data, note)
				VALUES
				($ID_MEMBER, $memID, $postid, " . time() . ", '$sdata', '$note')", __FILE__, __LINE__);

		// after we're here and no error happened, send the user-notifcation
		if(!empty($_POST['notify_check'])) {
			// send the pm. we don't log errors here, there's not all too much that can happen :P
			$_REQUEST['subject'] = isset($_REQUEST['subject']) ? trim($_REQUEST['subject']) : '';
			sendpm(array('to' => array($memID), 'bcc' => array()), $txt['warn_subject'], $_REQUEST['notify_text'], true);
		}

		// og log!
		logAction('warn', array ('user' => '<a href="' . $scripturl . '?action=profile;u=' . $memID . ';sa=warnLog#entry' . mysql_insert_id() . '">' . $context['member']['username'] . '</a>'));

		redirectexit('action=profile;u=' . $memID . ';sa=warnLog');
	}

	// Set the profile layer to be displayed.
	$context['sub_template'] = 'warn';

	// put this into the context, check if the warnings are active and get reply dates
	$context['warn_groups'] = $warningGroups;
	$context['postid'] = $postid;

	// grab latest warning
	$result = db_query("
		SELECT data, time
			FROM {$db_prefix}log_warnings
			WHERE ID_WARNED = $memID AND valid = 1
			ORDER BY ID_WARNING DESC
			LIMIT 1", __FILE__, __LINE__);
	$row = mysql_fetch_assoc($result);
	mysql_free_result($result);
	if(!empty($row)) {
		// 0 => ID_GROUP, 1 => expires
		$data = unserialize($row['data']);
		// iterate groups and get expiry dates
		foreach($data as $group => $expires)
			// if the group exists (maybe it got deleted by now?)
			if(isset($context['warn_groups'][$group]))
				$context['warn_groups'][$group]['is_warned']['expires'] = empty($expires) ? '0.00' : ($expires < 0 ? '-1' : (round(($expires + $row['time'] - time())/60/60/24, 2) > 0 ? number_format(round(($expires + $row['time'] - time())/60/60/24, 2), 2) : '0.00'));
	}

	// register this form and get a sequence number in $context.
	checkSubmitOnce('register');

}

function WarnLog ($memID) {

	global $context, $db_prefix, $txt, $warningGroups;

	$context['sub_template'] = 'warnlog';

	// get all warnings from the log and list them up
	$result = db_query("
		SELECT w.ID_WARNING, w.ID_MSG, mg.ID_TOPIC, w.time, w.valid, w.data, w.note, m.ID_MEMBER, m.memberName, m.realName
			FROM {$db_prefix}log_warnings as w
				LEFT JOIN {$db_prefix}members as m ON (w.ID_MEMBER = m.ID_MEMBER)
				LEFT JOIN {$db_prefix}messages as mg ON (mg.ID_MSG = w.ID_MSG)
			WHERE w.ID_WARNED = $memID
			ORDER BY w.ID_WARNING DESC", __FILE__, __LINE__);
	$context['entries'] = array();
	while($row = mysql_fetch_assoc($result)) {
		// iterate groups and get expiry dates
		$context['entries'][$row['ID_WARNING']] = array(
			'moderator' => empty($row['ID_MEMBER']) ? array() : array(
				'id' => $row['ID_MEMBER'],
				'name' => $row['memberName'],
				'displayname' => $row['realName'],
			),
			'postid' => $row['ID_MSG'],
			'topic' => $row['ID_TOPIC'],
			'groups' => unserialize($row['data']),
			'time' => timeformat($row['time']),
			'note' => parse_bbc($row['note']),
		);

		// fix up the time formatting
		foreach($context['entries'][$row['ID_WARNING']]['groups'] as $group => $expires)
			// not at all? how does this come here?? o-O
			if($expires == 0)
				unset($context['entries'][$row['ID_WARNING']]['groups'][$group]);
			// infinite
			elseif($expires < 0)
				$context['entries'][$row['ID_WARNING']]['groups'][$group] = $txt['warn_infinite'];
			// it's a real time :o)
			else
				$context['entries'][$row['ID_WARNING']]['groups'][$group] = (($row['time'] + $expires) < time() || !$row['valid'] ? $txt['warn_exp1'] : '') . timeformat($row['time'] + $expires) . (($row['time'] + $expires) < time() || !$row['valid'] ? $txt['warn_exp2'] : '');
	}
	mysql_free_result($result);

	// also needed by the template
	$context['warn_groups'] = $warningGroups;
}
</add after>



<edit file>
$themedir/Profile.template.php
</edit file>


<search for>
	// If the person looking at the summary has permission, and the account isn't activated, give the viewer the ability to do it themselves.
</search for>

<add before>
	// If the user is in any warning groups, show it!
	if (!empty($context['member']['warnings'])) {
		echo '
				<tr>
					<td colspan="2"><hr size="1" width="100%" class="hrcolor" /></td>
				</tr>';
		foreach($context['member']['warnings'] as $group)
			echo '
				<tr>
					<td colspan="2" style="padding-left: 20px; font-weight: bold', !empty($context['warn_groups'][$group]['onlineColor']) ? '; color: ' . $context['warn_groups'][$group]['onlineColor'] : '', ';">', !empty($context['warn_groups'][$group]['light']) ? '<img src="' . $settings['images_url'] . '/' . $context['warn_groups'][$group]['light'] . '" alt="" border="0" align="middle" />&nbsp;&nbsp;' : '-', $context['warn_groups'][$group]['groupName'], '</td>
				</tr>';
	}

</add before>


<search for>
			</ul>
		</div>';
}
</search for>

<add after>

function template_warn() {
	global $scripturl, $context, $txt, $settings;

	echo '
<form action="', $scripturl, '?action=profile;u=', $context['member']['id'], ';sa=warn" method="post" onsubmit="submitonce(this);">
	<table border="0" cellpadding="4" cellspacing="1" align="center" class="bordercolor">
		<tr class="titlebg">
			<td colspan="4" width="570" height="26">
				<img src="', $settings['images_url'], '/icons/package_installed.gif" alt="" border="0" align="middle" />&nbsp;<img src="', $settings['images_url'], '/icons/package_old.gif" alt="" border="0" align="middle" />&nbsp;
				', $txt['warn'], ' - ', $context['member']['name'], ' <a href="', $scripturl, '?action=helpadmin;help=warn_help" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="Help" border="0" align="top" /></a>
			</td>
		</tr>';
	if(empty($context['warn_groups']))
		echo '
		<tr class="windowbg">
			<td colspan="4">', $txt['nowarninggroups'], '</td>
		</tr>';
	else {
		foreach($context['warn_groups'] as $id => $group)
			echo '
		<tr class="windowbg">
			<td style="font-weight: bold', !empty($group['onlineColor']) ? '; color: ' . $group['onlineColor'] : '', ';">', $group['groupName'], '</td>
			<td align="center">', !empty($group['light']) ? '<img src="' . $settings['images_url'] . '/' . $group['light'] . '" alt="" border="0" align="middle" />' : '-', '</td>
			<td>', $txt['warned_for'], ' <input type="text" name="group[', $id, ']" value="', !empty($group['is_warned']) ? $group['is_warned']['expires'] : '0.00', '" /> ', $txt['warned_days'], '</td>
		</tr>';
		echo '
		<tr class="windowbg">
			<td>', $txt['warn_note'], '</td>
			<td colspan="3" align="center"><textarea name="note" cols="60" rows="4"></textarea></td>
		</tr>
		<tr class="windowbg">
			<td><input type="checkbox" class="check" id="notify_check" name="notify_check" onchange="document.getElementById(\'notify_text\').disabled = !this.checked" /> <label for="notify_check">', $txt['warn_notify'], '</label></td>
			<td colspan="3" align="center"><textarea id="notify_text" disabled="disabled" name="notify_text" cols="60" rows="4"></textarea></td>
		</tr>
		<tr class="windowbg">
			<td><input type="checkbox" class="check" id="post_check" name="post_check" onchange="document.getElementById(\'post_id\').disabled = !this.checked" ', !empty($context['postid']) ? ' checked="checked"' : '', ' /> <label for="post_check">', $txt['warn_post'], '</label></td>
			<td colspan="3" align="center"><input type="text" id="post_id" ', empty($context['postid']) ? 'disabled="disabled" ' : 'readonly="readonly"', 'name="post_id" ', !empty($context['postid']) ? 'value="' . $context['postid'] . '" ' : '', '/>', !empty($context['postid']) ? ' (<a href="' . $scripturl . '?topic=' . $context['topic'] . '.msg' . $context['postid'] . '#msg' . $context['postid'] . '" target="_blank">link</a>)' : '', '</td>
		</tr>
		<tr class="windowbg">
			<td colspan="4" align="center"><input type="submit" name="submit" value="', $txt['submit'], '" /></td>
		</tr>';
	}
	echo '
	</table>
	<input type="hidden" name="sc" value="', $context['session_id'], '" />
	<input type="hidden" name="seqnum" value="', $context['form_sequence_number'], '" />
</form>';

}

function template_warnlog () {

	global $scripturl, $context, $settings, $txt;

	echo '
	<table border="0" cellpadding="4" cellspacing="1" align="center" class="bordercolor">
		<tr class="titlebg">
			<td colspan="4" width="570" height="26">
				<img src="', $settings['images_url'], '/icons/package_installed.gif" alt="" border="0" align="middle" />&nbsp;<img src="', $settings['images_url'], '/icons/package_old.gif" alt="" border="0" align="middle" />&nbsp;
				', $txt['warnLog'], ' - ', $context['member']['name'], '
			</td>
		</tr>
		<tr class="windowbg">
			<td>', $txt['warn_info'], '</td>
			<td colspan="2">', $txt['warn_group'], '</td>
			<td>', $txt['warned_until'], '</td>
		</tr>';
	if(empty($context['warn_groups']))
		echo '
		<tr class="windowbg">
			<td colspan="4">', $txt['nowarninggroups'], '</td>
		</tr>';
	else {
		foreach($context['entries'] as $id => $entry) {
			echo '
			<a name="entry', $id, '"></a>
			<tr class="windowbg2">
				<td rowspan="', count($entry['groups'])+1, '">
					', $txt['warned_by'], ' <a href="', $scripturl, '?action=profile;u=', $entry['moderator']['id'], ';sa=summary">', $entry['moderator']['displayname'], '</a>', $entry['moderator']['name'] != $entry['moderator']['displayname'] ? ' (' . $entry['moderator']['name'] . ')' : '', ',
					', $entry['time'], !empty($entry['note']) ? '
					<div style="margin: 1px; padding: 2px; overflow: auto;">' . $entry['note'] . '</div>' : '', !empty($entry['topic']) ? '
					&nbsp;&nbsp;-> <a href="' . $scripturl . '?topic=' . $entry['topic'] . '.' . $entry['postid'] . '#msg' . $entry['postid'] . '">' . $txt['warn_related'] . '</a>' : '', '
				</td>';
			if(empty($entry['groups']))
				echo '
                                <td colspan="3" style="text-align: center;">', $txt['warn_unwarned'], '</td>
			</tr>';
			else
	  			foreach($entry['groups'] as $id => $expires)
  					echo '
			<tr class="windowbg2">
				<td width="1" align="center">', !empty($context['warn_groups'][$id]['light']) ? '<img src="' . $settings['images_url'] . '/' . $context['warn_groups'][$id]['light'] . '" alt="" border="0" align="middle" />' : '-', '</td>
				<td style="font-weight: bold', !empty($context['warn_groups'][$id]['onlineColor']) ? '; color: ' . $context['warn_groups'][$id]['onlineColor'] : '', ';">', !empty($context['warn_groups'][$id]['groupName']) ? $context['warn_groups'][$id]['groupName'] : $txt['nonexistantgroup'], '</td>
				<td>', $expires, '</td>
			</tr>';
		}
	}

	echo '
	</table>';

}
</add after>



<edit file>
$themedir/ManageMembergroups.template.php
</edit file>


<search for>
				<input type="hidden" name="postgroup" value="0" />
</search for>

<add after>
				<input type="hidden" name="warninggroup" value="0" />
</add after>


<search for>
				<input type="hidden" name="postgroup" value="1" />
</search for>

<add after>
				<input type="hidden" name="warninggroup" value="0" />
				<input type="hidden" name="generalgroup" value="0" />
			</form>
		</div><br />
		<div class="tborder">
			<form action="' . $scripturl . '?action=membergroups;sa=add" method="post" name="memberForm" style="margin: 0;">
				<table width="100%" border="0" cellpadding="2" cellspacing="1">
					<tr class="catbg"><td colspan="4" style="padding: 4px;">', $txt['membergroups_warning'], '</td></tr>
					<tr class="titlebg">
						<td width="42%">', $txt['membergroups_name'], '</td>
						<td width="12%" align="center">', $txt['membergroups_stars'], '</td>
						<td width="10%" align="center">', $txt['membergroups_members_top'], '</td>
						<td width="10%" align="center">', $txt[17], '</td>
					</tr>';
	foreach ($context['groups']['warning'] as $group) {
		echo '
					<tr>
						<td class="windowbg2">', empty($group['color']) ? $group['name'] : '<span style="color: ' . $group['color'] . '">' . $group['name'] . '</span>', '</td>
						<td class="windowbg2" align="left">', $group['stars'], '</td>
						<td class="windowbg" align="center">', $group['can_search'] ? $group['link'] : $group['num_members'], '</td>
						<td class="windowbg2" align="center"><a href="' . $scripturl . '?action=membergroups;sa=edit;group=' . $group['id'] . '">' . $txt['membergroups_modify'] . '</a></td>
					</tr>';
	}

	echo '
					<tr class="windowbg">
						<td colspan="4" align="right" style="padding-top: 1ex; padding-bottom: 2ex;">
							<input type="submit" value="', $txt['membergroups_add_group'], '" style="margin: 4px;" />
						</td>
					</tr>
				</table>
				<input type="hidden" name="sc" value="' . $context['session_id'] . '" />
				<input type="hidden" name="postgroup" value="0" />
				<input type="hidden" name="warninggroup" value="1" />
				<input type="hidden" name="generalgroup" value="0" />
</add after>


<search for>
						<input type="checkbox" name="postgroup_based" id="postgroup_based_check" value="1" onclick="updateStatus();" class="check" />
					</td>
</search for>

<add after>
				</tr>
				<tr class="windowbg2">
					<th align="right"><label for="warninggroup_based_check">', $txt['membergroups_edit_warning_group'], ':</label></th>
					<td>
						<input type="hidden" name="warninggroup_based" value="0" />
						<input type="checkbox" name="warninggroup_based" id="warninggroup_based_check" value="1" onclick="updateStatus();" class="check" />
					</td>

</add after>


<search for>
	if (!$context['post_group'] || !empty($modSettings['permission_enable_postgroups']))
</search for>

<add before>
	if ($context['warning_group'])
		echo '
				<input type="hidden" name="warninggroup_based" value="1" />';
</add before>


<search for>
						', $txt['membergroups_new_board'], ':', $context['post_group'] ? '<div class="smalltext" style="font-weight: normal">' . $txt['membergroups_new_board_post_groups'] . '</div>' : '', '
</search for>

<replace>
						', $txt['membergroups_new_board'], ':', ($context['undefined_group'] || $context['post_group']) ? '<div class="smalltext" id="postgroup_boardnote" style="font-weight: normal">' . $txt['membergroups_new_board_post_groups'] . '</div>' : '', ($context['undefined_group'] || $context['warning_group']) ? '<div class="smalltext" id="warninggroup_boardnote" style="font-weight: normal; color: red;">' . $txt['membergroups_new_board_warning_groups'] . '</div>' : '', '
</replace>


<search for>
							<legend>', $txt['membergroups_new_board_desc'], '</legend>';
</search for>

<replace>
							<legend id="board_legend">', $txt['membergroups_new_board_desc'], '</legend>';
</replace>


<search for>
			<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
				function updateStatus()
				{
					var postgroupBased = document.getElementById(\'postgroup_based_check\').checked;
					document.getElementById(\'min_posts_input\').disabled = !postgroupBased;';
		if (empty($modSettings['permission_enable_postgroups']))
			echo '
					document.getElementById(\'perm_type_predefined\').disabled = postgroupBased;
					document.getElementById(\'perm_type_copy\').disabled = postgroupBased;
					document.getElementById(\'level_select\').disabled = postgroupBased;
					document.getElementById(\'copyperm_select\').disabled = postgroupBased;';
		echo '
				}
				updateStatus();
			// ]]></script>';
</search for>

<replace>
			<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
				function updateStatus() {
					var postgroupBased = document.getElementById(\'postgroup_based_check\').checked;
					document.getElementById(\'warninggroup_based_check\').disabled = postgroupBased;
					var warninggroupBased = document.getElementById(\'warninggroup_based_check\').checked;
					document.getElementById(\'postgroup_based_check\').disabled = warninggroupBased;

					document.getElementById(\'min_posts_input\').disabled = !postgroupBased;';
		if (empty($modSettings['permission_enable_postgroups']))
			echo '
					document.getElementById(\'perm_type_predefined\').disabled = postgroupBased;
					document.getElementById(\'perm_type_copy\').disabled = postgroupBased;
					document.getElementById(\'level_select\').disabled = postgroupBased;
					document.getElementById(\'copyperm_select\').disabled = postgroupBased;';
		echo '
					document.getElementById(\'postgroup_boardnote\').style.display = postgroupBased ? \'block\' : \'none\';
					document.getElementById(\'warninggroup_boardnote\').style.display = warninggroupBased ? \'block\' : \'none\';
					// TODO: this does not work in opera, gotta check if it works for other browsers, and/or find a way to fix!!
					if(warninggroupBased)
						document.getElementById(\'board_legend\').title = \'', addslashes($txt['membergroups_new_board_warning_desc']), '\';
					else
						document.getElementById(\'board_legend\').title = \'', addslashes($txt['membergroups_new_board_desc']), '\';
				}
				updateStatus();
			// ]]></script>';
</replace>


<search for>
				</tr>';
	if ($context['group']['allow_post_group'])
</search for>

<replace>
				</tr>';
	if ($context['group']['allow_special_groups'])
</replace>


<search for>
					<th align="right"><label for="post_group_check">', $txt['membergroups_edit_post_group'], ':</label></th>
					<td><input type="checkbox" name="post_group" id="post_group_check" value="1"', $context['group']['is_post_group'] ? ' checked="checked"' : '', ' onclick="swapPostGroup(this.checked);" class="check" /></td>
				</tr>
				<tr class="windowbg2">
					<th align="right" id="min_posts_text"><label for="min_posts_input">', $txt['membergroups_min_posts'], ':</label></th>
					<td><input type="text" name="min_posts" id="min_posts_input"', $context['group']['is_post_group'] ? ' value="' . $context['group']['min_posts'] . '"' : '', ' size="6" /></td>
</search for>

<replace>
					<th align="right" id="warning_group_text"><label for="warning_group_check">', $txt['membergroups_edit_warning_group'], ':</label></th>
					<td><input type="checkbox" name="warning_group" id="warning_group_check" value="1"', $context['group']['is_warning_group'] ? ' checked="checked"' : '', ' onclick="updateStatus();" class="check" /></td>
				</tr>
				<tr class="windowbg2">
					<th align="right" id="post_group_text"><label for="post_group_check">', $txt['membergroups_edit_post_group'], ':</label></th>
					<td><input type="checkbox" name="post_group" id="post_group_check" value="1"', $context['group']['is_post_group'] ? ' checked="checked"' : '', ' onclick="updateStatus();" class="check" /></td>
				</tr>
				<tr class="windowbg2">
					<th align="right" id="min_posts_text"><label for="min_posts_input">', $txt['membergroups_min_posts'], ':</label></th>
					<td><input type="text" name="min_posts" id="min_posts_input"', $context['group']['is_post_group'] ? ' value="' . $context['group']['min_posts'] . '"' : '', ' size="6" /></td>
</replace>


<search for>
	if ($context['group']['allow_post_group'])
		echo '
		<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
			function swapPostGroup(isChecked)
			{
				var min_posts_text = document.getElementById(\'min_posts_text\');
				document.groupForm.min_posts.disabled = !isChecked;
				min_posts_text.style.color = isChecked ? "" : "#888888";
			}
			swapPostGroup(', $context['group']['is_post_group'] ? 'true' : 'false', ');
		// ]]></script>';
</search for>

<replace>
	if($context['group']['allow_special_groups'])
		echo '
		<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
			function updateStatus() {
				// one of them is it, disable the other :P
				var warninggroup = document.getElementById(\'warning_group_check\').checked;
				document.getElementById(\'post_group_check\').disabled = warninggroup;
				var postgroup = document.getElementById(\'post_group_check\').checked;
				document.getElementById(\'warning_group_check\').disabled = postgroup;

				document.getElementById(\'warning_group_text\').style.color = postgroup ? \'#888888\' : \'\';
				document.getElementById(\'post_group_text\').style.color = warninggroup ? \'#888888\' : \'\';

				document.getElementById(\'min_posts_text\').style.color = postgroup ? \'\' : \'#888888\';
				document.getElementById(\'min_posts_input\').disabled = !postgroup;
			}
			updateStatus();
		// ]]></script>';
</replace>



<edit file>
$themedir/languages/Modifications.english.php
</edit file>


<search for>
// Version: 1.1 Beta 3 Public; Modifications
</search for>

<add after>
$txt['submit'] = 'Submit';

$txt['warn'] = 'Warn User';
$txt['warnLog'] = 'Warning Log';

$txt['permissiongroup_vwarn'] = 'VWarn Mod';
$txt['permissionname_vwarn_warn'] = 'Warn users';
$txt['permissionhelp_vwarn_warn'] = 'Users with this permission may warn other users.';
$txt['cannot_vwarn_warn_any'] = 'You do not have the permission to warn users.';

$txt['permissionname_vwarn_viewlog'] = 'View warning log';
$txt['permissionhelp_vwarn_viewlog'] = 'Allows the user to view his own or any warning logs.';
$txt['permissionname_vwarn_viewlog_own'] = 'Own Log';
$txt['cannot_vwarn_viewlog_own'] = 'Sorry, you\'re not allowed to view your warning log.';
$txt['permissionname_vwarn_viewlog_any'] = 'Any Log';
$txt['cannot_vwarn_viewlog_any'] = 'Sorry, you\'re not allowed to view other members\' warning logs.';

$txt['warned_for'] = 'Lasting';
$txt['warned_days'] = 'days';
$txt['warned_by'] = 'By';
$txt['warned_until'] = 'Expires / Expired';
$txt['warn_group'] = 'Group';
$txt['warn_note'] = 'Note';
$txt['warn_notify'] = 'Send notification';
$txt['warn_post'] = 'Related post ID';
$txt['warn_infinite'] = 'Does not expire';
$txt['warn_info'] = '';
$txt['warn_related'] = 'Related Post';
$txt['warn_unwarned'] = 'Unwarned';

$txt['warn_subject'] = 'Your warning level changed';

$txt['nonexistantgroup'] = '[ Unknown ]';

$txt['warn_exp1'] = '<span style="color: grey;">';
$txt['warn_exp2'] = '</span>';

$txt['nowarninggroups'] = 'There are no "warning" type membergroups.';
$txt['postnotusers'] = 'Post doesn\'t match user or does not exist.';

$txt['membergroups_warning'] = 'Warning member groups';
$txt['membergroups_new_board_warning_desc'] = 'Boards the membergroup can NOT see';
$txt['membergroups_new_board_warning_groups'] = '<em>Note: for warning groups, you check all boards the member should NOT have access to!</em>';
$txt['membergroups_edit_warning_group'] = 'This group is a warning group';

$txt['warn_help'] = 'Specify the number of days each warning level is supposed to last. The user will be in all unexpired levels, though only the one with the shortest expiry time is shown in the post-profile.<br /><br />0 days = Not warned<br />-1 days = Does not expire<br /><br /><i>Set all levels to 0 to unwarn!</i>';

</add after>



<edit file>
$sourcedir/ModSettings.php
</edit file>


<search for>
			array('check', 'autoFixDatabase'),
</search for>

<add after>
			array('int', 'autoWarnDelay'),
</add after>



<edit file>
$themedir/languages/ModSettings.english.php
</edit file>


<search for>
$txt['autoFixDatabase'] = 'Automatically fix broken tables';
</search for>

<add after>
$txt['autoWarnDelay'] = 'Warning expiration delay';
</add after>



<edit file>
$themedir/languages/Help.english.php
</edit file>


<search for>
$helptxt['autoFixDatabase'] = 'This will automatically fix broken tables and resume like nothing happened.  This can be useful, because the only way to fix it is to REPAIR the table, and this way your forum won\'t be down until you notice.  It does email you when this happens.';
</search for>

<add after>
$helptxt['autoWarnDelay'] = 'The frequence the unwarn-routine is called, in seconds.';
</add after>



<edit file>
$sourcedir/ManagePermissions.php
</edit file>


<search for>
		WHERE mg.minPosts = -1" : '') . "
</search for>

<replace>
		WHERE mg.minPosts < 0" : '') . "
</replace>

<search for>
			'is_post_group' => $row['minPosts'] != -1,
</search for>

<replace>
			'is_post_group' => $row['minPosts'] >= 0,
</replace>


<search for>
				WHERE minPosts != -1", __FILE__, __LINE__);
</search for>

<replace>
				WHERE minPosts >= 0", __FILE__, __LINE__);
</replace>


<search for>
			AND mg.minPosts = -1" : ''), __FILE__, __LINE__);
</search for>

<replace>
			AND mg.minPosts < 0" : ''), __FILE__, __LINE__);
</replace>


<search for>
				'profile_remote_avatar' => false,
			)
</search for>

<replace>
				'profile_remote_avatar' => false,
			),
			'vwarn' => array(
				'vwarn_warn' => false,
				'vwarn_viewlog' => true,
			)
</replace>


<edit file>
$sourcedir/Display.php
</edit file>


<search for>
		'can_moderate_forum' => 'moderate_forum'
</search for>

<replace>
		'can_moderate_forum' => 'moderate_forum',
		'can_warn' => 'vwarn_warn'
</replace>



<edit file>
$themedir/Display.template.php
</edit file>


<search for>
			// Is karma display enabled?  Total or +/-?
</search for>

<add before>
			// Show warning light, if there is one
			if (!empty($message['member']['warning']))
				echo '<span style="margin: 10px; font-size: 10pt; font-weight: bold', !empty($message['member']['warning']['color']) ? '; color: ' . $message['member']['warning']['color'] : '', ';">', !empty($message['member']['warning']['light']) ? '<img src="' . $settings['images_url'] . '/' . $message['member']['warning']['light'] . '" alt="" border="0" align="middle" />&nbsp;&nbsp;' : '', $message['member']['warning']['name'], '</span><br />';
</add before>


<search for>
		// Can they reply?  Have they turned on quick reply?
</search for>

<add before>

		// Show warning button, if they can warn
		if (!empty($context['can_warn']) && empty($message['member']['is_guest']))
			echo '
									<a href="', $scripturl, '?action=profile;u=', $message['member']['id'], ';sa=warn;postid=', $message['id'], ';sesc=', $context['session_id'], '">', ($settings['use_image_buttons'] ? '<img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/warn.gif" alt="' . $txt['warn'] . '" border="0" />' : $txt['warn']), '</a>';
</add before>